SystemOrganization addCategory: #'GT-Inspector'!

!ContextPart methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/22/2012 20:38'!
gtInspectorRetrieveVariableValuePairs
	"We override the variables with context specific ones"
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorRetrieveVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName | 
							tempIndex := tempIndex + 1.
							('[' , tempName , ']') -> (self debuggerMap namedTempAt: tempIndex in: self) ]);
		yourself! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGriba 5/14/2013 16:01'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 10>
	composite text
			title: 'Contents';
			display: [ :each | each readStreamDo: [ :stream | stream contents ] ];
			when: [ :each | each isFile ]! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 10/20/2011 15:44'!
gtInspectorITextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'String'! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a String"! !

!ComposableModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/2/2013 16:38'!
gtInspectorModelNestingIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Nesting';
		display: [ :root | { 'root' -> self } ];
		children: [ :each | 
			each value class allInstVarNames 
				collect: [ :iv | iv->(each value instVarNamed: iv) ]
				thenSelect: [ :association | 
					(association value isKindOf: ComposableModel) 
						and: [ (#('owner' 'window') includes: association key) not ] ] ];
		format: [ :association | association key , ': ' , association value asString ];
		send: #value! !

!ComposableModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/3/2013 17:49'!
gtInspectorSpecIn: composite
	<gtInspectorPresentationOrder: 30>
	composite spec 
		title: 'Preview';
		when: [ self widget notNil ]! !

!Bitmap methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 15:10'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:each | self imageForm asMorph ];
		act: [ :pres | self exportAsPNG ] entitled: 'Export as PNG'! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/2/2012 03:22'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notEmpty ]! !

!ROMondrianViewBuilder methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 19:30'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		view: self! !

!WindowModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/2/2013 16:31'!
gtInspectorModelNestingIn: composite
	self model gtInspectorModelNestingIn: composite! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self compiledMethod implementors ]! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self compiledMethod senders ]! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 05:43'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30>
	self compiledMethod gtInspectorSourceIn: composite! !

!GLMPane methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 13:38'!
gtInspectorPortsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Ports';
		display: [ self ports ];
		column: 'Port' evaluated: [ :each | each name ];
		column: 'Value' evaluated: [ :each | each value asString ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/23/2011 07:30'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Bytecode';
		display: [:anObject | anObject symbolic ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'AndreiChis 12/19/2013 16:33'!
gtInspectorIrIn: composite
	<gtInspectorPresentationOrder: 35> 
	composite text 
		title: 'Ir';
		display: [ :anObject || string |
				string := anObject ir longPrintString.
				string copyFrom: 2 to: string size ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 9/7/2012 13:04'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite tabulator 
		title: 'Pragmas';
		when: [ :x | x pragmas notEmpty ];
		with: [ :t |  
		t row: #pragmas; row: #methods.
		t transmit to: #pragmas; andShow: [:a | 
			a list
				title: 'Pragmas';
				display: [ :method | method pragmas ];
				when: [ :x | x pragmas notEmpty ] ].
		t transmit from: #pragmas; to: #methods; andShow: [:a | 
			a list 
				title: 'Methods';
				display: [ :pragma | 
					| methods | 
					methods := OrderedCollection new.
					Object withAllSubclassesDo: [ :each | 
						methods addAll: ((Pragma allNamed: pragma keyword in: each) collect: #method) ].
					methods ];
				format: #selector ]
			];
		startOn: self! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:33'!
gtInspectorRetrieveVariableValuePairs
	| literalIndex |
	literalIndex := 0.
	^ OrderedCollection new 
		add: ( '_self' -> self);
		add: ( 'header' -> self headerDescription );
		addAll: ( self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> self symbolic );
		yourself
! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 16:02'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self getSource ];
		act: [ self browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!Symbol methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self systemNavigation allImplementorsOf: self ];
		when: [ (self systemNavigation allImplementorsOf: self) notEmpty ];
		showOnly: 30! !

!Symbol methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self systemNavigation allSendersOf: self ];
		when: [ (self systemNavigation allSendersOf: self) notEmpty ];
		showOnly: 30! !

!Set methodsFor: '*gt-inspector' stamp: 'TudorGirba 5/30/2012 06:49'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:set | set asOrderedCollection]! !

!ROView methodsFor: '*gt-inspector' stamp: 'TudorGirba 9/6/2013 20:35'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Elements';
		display: [ :each | {each} ];
		children: #elements! !

!ROView methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 20:34'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		initializeView: [self]! !

!MethodContext methodsFor: '*gt-inspector' stamp: 'TudorGirba 11/13/2013 06:44'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:46'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: [ :anObject | self size asString, ' items' ];
		display: [ self associations];
		column: 'Key' evaluated: [:each | GTObjectPrinter asSimpleTextFrom: each ];
		column: 'Value' evaluated: [:each | GTObjectPrinter asSimpleTextFrom: each ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | (selection notNil and: [selection size = 1]) 
				ifTrue: [selection anyOne value] 
				ifFalse: [selection collect: #value] ];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:33'!
gtInspectorRetrieveVariableValuePairs  
	^ OrderedCollection new 
		add: ( '_self' -> self); 
		add: ( 'tally' -> self size );
		add: ( 'array' -> self array );
		yourself
! !

!Color methodsFor: '*gt-inspector' stamp: 'TudorGirba 11/18/2013 11:46'!
gtInspectorColorIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph 
		title: 'Color';
		display: [ BorderedMorph new color: self ]! !

!Text methodsFor: '*gt-inspector' stamp: 'TudorGirba 11/18/2013 20:53'!
gtInspectorITextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'Text';
		format: self! !

!Text methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:45'!
gtInspectorItemsIn: composite
	"No items presentation for a Text"! !

!Collection methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:46'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (composite list)
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | self ];
		beMultiple;
		withSmalltalkSearch;		
		format: [ :each | GTObjectPrinter new asSimpleTextFrom: each ];
		send: [ :result | (result notNil and: [result size = 1]) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!GLMSystemWindow methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (self model 
		gtInspectorOpenTreeIn: composite)
		title: 'Browser tree'! !

!ReadStream methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 13:00'!
gtInspectorStreamStateIn: composite
	<gtInspectorPresentationOrder: 50>
	(composite wrapper with: [ :w | 
		w title: 'Contents'.
		w show: [ :a | 
			a text
				display: [ self contents ];
				initialize: [ :aPresentation | 
					aPresentation selectionInterval: (1 to: self position) ] ] ])
		startOn: self! !

!GLMCompositePresentation methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMCompositePresentation methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 16:18'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

GLMCompositePresentation subclass: #GTInspector
	instanceVariableNames: ''
	classVariableNames: 'GTNumberOfInspectorPanes'
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 8/21/2011 16:57' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One particular feature is that you can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

Example:
self openOn: Smalltalk.

Register it as a replacement for explorer:
self registerToolsOn: Smalltalk tools.!

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
explore: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'class initialization' stamp: 'TudorGirba 10/7/2012 22:50'!
initialize 
	self numberOfInspectorPanes: 2! !

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
inspect: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'openning' stamp: 'AndreHora 11/2/2013 00:17'!
inspector: anObject

	^ self inspect: anObject! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes
	^ GTNumberOfInspectorPanes ! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes: anInteger
	GTNumberOfInspectorPanes := anInteger ! !

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/25/2012 22:53'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTInspector class methodsFor: 'tools registry' stamp: 'TudorGirba 11/1/2013 22:17'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools " 
	registry register: self as: #inspector
! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/8/2012 20:13'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder group: #glamorousInspector)
		label: 'Glamorous Inspector';
		with: [
			(aBuilder setting: #numberOfInspectorPanes)
				target: self; 
				label: 'Number of inspector panes';
		 		description: 'Specifies the maximum number of panes that are visible at every moment in a Glamorous Inspector.'.]! !

!GTInspector methodsFor: 'building' stamp: 'TudorGirba 11/14/2013 06:15'!
compose
	self title: [:anObject | 'Inspector on ', (self printObjectAsAnItem: anObject)].
	self act: [:b | b update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Update'.
	self finder with: [:browser | 
		browser fixedSizePanes: self class numberOfInspectorPanes.
		browser show: [ :a :each | 
			a title: [ :anObject | self printObjectAsAnItem: anObject ].
			a 
				morphicAct: [:composite | composite entity browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'.

			a dynamic display: [ :x | 
				GLMCompositePresentation new with: [:d | each gtInspectorPresentationsIn: d ] ] ] ]! !

!GTInspector methodsFor: 'opening' stamp: 'TudorGirba 8/21/2011 08:56'!
openExplorerFor: anObject
	"this method is needed for compatibility with ObjectExplorer"
	self openOn: anObject! !

!GTInspector methodsFor: 'private' stamp: 'TudorGirba 8/22/2011 11:05'!
printObjectAsAnItem: anObject 
	| title stream previewString |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	previewString := [ Text fromString: (anObject printString contractTo: 10) ]
						on: Error
						do: [ 'error printing' ].
	stream 
		nextPutAll: ' (';
		nextPutAll: previewString;
		nextPut: $).
	^ stream contents! !

GLMCompositePresentation subclass: #GTObjectVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectVariablesBrowser commentStamp: 'TudorGirba 8/22/2011 12:52' prior: 0!
This is a helper browser for the main view in the GTInspector.

Example:
self openOn: Smalltalk!

!GTObjectVariablesBrowser methodsFor: 'building' stamp: 'AndreiChis 4/2/2013 23:05'!
buildBrowser 
	browser := GLMTabulator new.
	browser title: 'State'.
	browser row: #variables; row: #evaluator.
	browser transmit to: #variables; andShow: [:a | 
		self variablesIn: a ].
	browser transmit to: #evaluator; andShow: [:a | 
		self evaluatorIn: a ].
	browser transmit from: #variables; toOutsidePort: #selection.
	browser transmit from: #evaluator; toOutsidePort: #selection.
	browser transmit from: #variables port: #strongSelection; toOutsidePort: #strongSelection.
	browser transmit from: #evaluator port: #strongSelection; toOutsidePort: #strongSelection.
	^ browser ! !

!GTObjectVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 22:38'!
compose
	self title: 'State'.
	self tabulator with: [ :browser |
		browser row: #variables; row: #evaluator.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit to: #evaluator; andShow: [:a | 
			self evaluatorIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection.
		browser transmit from: #evaluator; toOutsidePort: #selection ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 11/27/2013 15:09'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :object | 
			String streamContents: [ :stream | 
				stream 
					nextPutAll: (self printStringOf: object);
					cr;
					nextPutAll: (GTSnippets snippetAt: object)] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ] ! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 11/27/2013 14:53'!
printStringOf: anObject
	^ [(anObject printString contractTo: 200) asSmalltalkComment] 
			on: Error 
			do: ['"Error printing. Try self printString to debug"']! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 12/6/2013 14:59'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :anObject | anObject gtInspectorRetrieveVariableValuePairs ];
		sorted: [:assoc1 :assoc2 | assoc1 key < assoc2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect'! !

GLMCompositePresentation subclass: #GTSimpleMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleMethodsBrowser commentStamp: '<historical>' prior: 0!
This browser is used to browse the class structure of every object in the inspector.

self openOn: World!

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 11/24/2013 08:37'!
accumulatedSourceOf: m for: object in: composite
	composite accumulator with: [ :acc | 
		acc show: [ :a |
			a title: [ :method | method selector ].
			self sourceOf: m for: object in: a ] ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:05'!
classesIn: a
	^ a list
		display: [ :object | 
			| all |
			all := OrderedCollection new.
			object class withAllSuperclassesDo: [:each | all add: each ].
			all ];
"		initialize: [ :list | list selection: list entity class ];"
		format: [ :class | class name ];
		morphicSelectionAct: [ :list | Smalltalk tools browser fullOnClass: list selection ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse'! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/17/2013 10:23'!
compose
	self title: 'Methods'.
	self tabulator with: [ :browser |
		browser
			row: [ :r | r column: #classes; column: #methods span: 3 ];
			row: #source.
		browser transmit
			to: #classes;
			andShow: [ :a | self classesIn: a ].
		browser transmit
			to: #classes port: #selection;
			transformed: [:each | each class ].
		browser transmit
			fromOutsidePort: #entity;
			from: #classes;
			to: #methods;
			andShow: [ :a | self methodsIn: a ].
		browser transmit
			from: #methods;
			fromOutsidePort: #entity;
			to: #source;
			when: [ :method | method notNil ];
			andShow: [ :a :method :object | self sourceOf: method for: object in: a ].
		browser transmit
			toOutsidePort: #selection;
			from: #methods port: #evaluatedObject.
		browser transmit
			toOutsidePort: #selection;
			from: #source port: #evaluatedObject.
	]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 7/15/2012 18:07'!
evaluationAction
	^ GLMGenericAction new
		action: [ :listPresentation :obj | 
					| result |
					result := obj perform: listPresentation selection selector.
					(listPresentation pane port: #evaluatedObject) value: result ];
		shortcut: $o;
		title: 'Do it and open';
		yourself! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 7/15/2012 18:58'!
methodActionsFor: aMethod
	^ aMethod selector isUnary
		ifTrue: [ Array with: self evaluationAction ]
		ifFalse: [ #() ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/17/2013 08:00'!
methodsIn: a
	^ a list
		display: [ :object :class | class methods collect: #asRingDefinition];
		filterOn: [ :text :each | (text , '*') match: each selector ];
		tags: [ :method | method category ];
		sorted: [ :method1 :method2 | method1 selector < method2 selector ];
		format: [ :method | method selector ];
		morphicSelectionAct: [ :list :object :class | 
			Smalltalk tools browser 
				fullOnClass: class 
				selector: list selection selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse';
		dynamicActionsOnSelection: [ :list | self methodActionsFor: list selection ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/17/2013 15:26'!
sourceOf: method for: object in: composite
	^ composite smalltalkCode
		display: [ :m | m sourceCode ];
		smalltalkClass: [ :m | m methodClass ];
		doItReceiver: [ object ];
		selectionPopulate: #evaluatedObject
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text | Compiler evaluate: text selectedText for: object logged: false ];
		act: [ :text :m | self updateOuterPaneFrom: text for: method ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept'! !

!GTSimpleMethodsBrowser methodsFor: 'private' stamp: 'TudorGirba 12/17/2013 15:27'!
updateOuterPaneFrom: text for: method
	"this is a utility method to tell the pane surrounding the browser to update.
	The reason we do that is to support the use case of updating the GTInspector from
	the editor by modifying code directly in the Inspector."
	
	| outerPane newMethod |
	newMethod := method methodClass compile: text text notifying: nil.
	outerPane := text pane browser pane.
	outerPane update.
	self
		flag:
			'This is a huge hack because of so many reasons:
				- the presentation accesses the state of the outer browser directly
				- the presentation depends on the implementation of the browser 
				It should be solved through transmissions.
				
				But, it works for now and the browser is reasonably updated'.
	^ outerPane
		withAllPanesAndPresentationsDo: [ :child | 
			(child isKindOf: self class)
				ifTrue: [ 
					((child first paneNamed: #classes) port: #selection) value: method methodClass.
					((child first paneNamed: #methods) port: #selection)
						value:
							((child first paneNamed: #methods) presentations first displayedValue detect: [ :each | each selector = newMethod ]) ] ]! !

GLMCompositePresentation subclass: #GTSimpleParseTreeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleParseTreeBrowser commentStamp: '<historical>' prior: 0!
This is a simple browser that displays the rb tree and previews each node on the source code.

Example:
self openOn: (self>>#compose) parseTree!

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:09'!
compose
	self title: 'Tree'.
	self tabulator with: [ :browser |
		browser
			row: #tree;
			row: #source.
		browser transmit
			to: #tree;
			andShow: [ :a | self treeIn: a ].
		browser transmit
			to: #source;
			andShow: [ :a | self sourceIn: a ].
		browser transmit
			from: #tree;
			to: #source port: #selectionInterval;
			transformed: [ :rbNode | rbNode sourceInterval ].
		browser transmit
			toOutsidePort: #selection;
			from: #tree port: #selectedNode ]! !

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 11/29/2013 14:56'!
sourceIn: a
	^ a smalltalkCode 
		smalltalkClass: [ :each | each parents first methodClass ]; 
		display: [ :each | each source ]! !

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:17'!
treeIn: a
	^ a tree
		rootsExpanded;
		display: [ :anObject | {anObject} ];
		children: [ :each | each children ];
		selectionPopulate: #selectedNode
			on: $o
			entitled: 'Open'
			with: [ :tree | tree selection ];
		format: [ :each | 
					String
						streamContents: [ :stream | 
							stream
								nextPutAll: each class name;
								nextPut: $(;
								nextPutAll: ((each formattedCode truncateTo: 50) copyReplaceAll: String cr with: String space);
								nextPut: $) ] ]! !

!Float methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:19'!
gtInspectorRetrieveVariableValuePairs
	"We override the default variables to add significand and exponent"
	| bindings |
	bindings := super gtInspectorRetrieveVariableValuePairs.
	bindings
		add: 'significand' -> self significand;
		add: 'exponent' -> self exponent.
	^ bindings! !

!TraitDescription methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/4/2013 10:51'!
gtInspectorUsersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 	
		title: 'Users';
		display: [ 
			Smalltalk allClasses select: [ :class |
			   class traitComposition traits includes: self ] ]! !

!Form methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:object | object asMorph]! !

!Integer methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:32'!
gtInspectorRetrieveVariableValuePairs
	"We override the default variables to add representations for various bases"
	^ super gtInspectorRetrieveVariableValuePairs
		add: 'hex' -> self printStringHex;
		add: 'octal' -> (self printStringBase: 8);
		add: 'binary' -> (self printStringBase: 2);
		yourself! !

!SmallDictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 6/1/2012 22:10'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:smallDictionary  | smallDictionary associations asOrderedCollection]! !

!RBProgramNode methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/22/2012 20:38'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite custom: (GTSimpleParseTreeBrowser new browser startOn: self)! !

!Announcer methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 21:11'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Subscriptions';
		display: [ self subscriptions glmSubscriptions ];
		column: 'Subscriber' evaluated: [ :each | each subscriber asString ];
		column: 'Announcement' evaluated: [ :each | each announcementClass name ];
		column: 'Kind' evaluated: [ :each | each class name ];
		act: [ :table | 
			self subscriptions reset.
			table reset ] icon: GLMUIThemeExtraIcons glamorousCancel entitled: 'Reset';
		selectionAct: [ :table | 
			self subscriptions remove: table selection.
			table update ] entitled: 'Remove subscription'! !

!GLMBrowser methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMBrowser methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!SequenceableCollection methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:46'!
gtInspectorItemsIn: composite
	^ composite table
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | (1 to: self size) collect: [ :index | index -> (self at: index) ] ];
		beMultiple;
		withSmalltalkSearch;
		column: 'Item' evaluated: [ :assoc | GTObjectPrinter asSimpleTextFrom: assoc value ];
		column: 'Index' evaluated: [ :assoc | assoc key asString ];
		send: [ :result | (result notNil and: [result size = 1]) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!ByteArray methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a ByteArray"! !

!ZnMessage methodsFor: '*gt-inspector' stamp: 'TudorGirba 7/16/2013 22:17'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers headers gtInspectorItemsIn: composite) 
		display: [:anObject | self headers headers associations ];
		title: [:anObject | self headers headers size asString , ' header items' ]! !

!Pragma class methodsFor: '*gt-inspector' stamp: 'TudorGirba 10/4/2013 22:16'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite table 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			(pragmas groupedBy: #keyword) associations sorted: [ :a :b | 
				a key < b key ]
		];
		column: 'Keyword' evaluated: [ :each | each key ];
		column: 'Instances' evaluated: [ :each | each value size asString ];
		send: #value! !

!Pragma methodsFor: '*gt-inspector' stamp: 'TudorGirba 10/6/2013 22:09'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

Object subclass: #GTObjectPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectPrinter commentStamp: '<historical>' prior: 0!
This is a utility class for printing objects to Text or String!

!GTObjectPrinter methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/21/2013 22:43'!
asSimpleTextFrom: anObject
	^ [ Text fromString: ((anObject asString contractTo: 50) replaceAll: String cr with: String space) ] 
			on: Error 
			do: [ Text string: 'error printing' attribute: TextColor red ]! !

Object subclass: #GTSnippets
	instanceVariableNames: 'instance snippets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

GTSnippets class
	instanceVariableNames: 'instance'!

GTSnippets class
	instanceVariableNames: 'instance'!

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 14:55'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:00'!
snippetAt: anObject
	^ self instance snippetAt: anObject! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:10'!
snippetAt: anObject put: aString
	^ self instance snippetAt: anObject put: aString! !

!GTSnippets methodsFor: 'as yet unclassified' stamp: 'TudorGirba 11/27/2013 14:59'!
snippetAt: anObject
	^ self snippets 
		at: anObject class 
		ifAbsent: [ 'self' ]! !

!GTSnippets methodsFor: 'as yet unclassified' stamp: 'TudorGirba 11/27/2013 14:59'!
snippetAt: anObject put: aString
	^ self snippets 
		at: anObject class 
		put: aString! !

!GTSnippets methodsFor: 'as yet unclassified' stamp: 'TudorGirba 11/27/2013 14:59'!
snippets 
	^ snippets ifNil: [ snippets := IdentityDictionary new ]! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 10:20'!
gtInspectorMethodsIn: composite
	<gtInspectorPresentationOrder: 1000>
	composite custom: (GTSimpleMethodsBrowser new startOn: self) ! !

!Object methodsFor: '*gt-inspector' stamp: 'AndreiChis 10/24/2012 21:25'!
gtInspectorPresentationsIn: composite
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object 
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		self perform: eachPragma selector with: composite ]
! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/28/2011 23:31'!
gtInspectorRetrieveVariableValuePairs
	"This is a helper method that returns a collection of variable names -> value for the current object.
	Subclasses can override it to specialize what appears in the variables presentation"
	| bindings |
	bindings := self class allInstVarNames 
					collect: [ :iv | iv -> (self instVarNamed: iv) ].
	^ OrderedCollection new
		add: '_self' -> self;
		addAll: bindings;
		yourself! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:36'!
gtInspectorStateIn: composite
	<gtInspectorPresentationOrder: 10>
	composite custom: (GTObjectVariablesBrowser new startOn: self)! !
GTInspector initialize!
